Qt Reference Documentation

# QDBusContext Class Reference

The QDBusContext class allows slots to determine the D-Bus context of the calls. More...

     #include <QDBusContext>

This class was introduced in Qt 4.3.

- List of all members, including inherited members

## Public Functions

| QDBusContext ()
| ~QDBusContext ()
bool | calledFromDBus () const
QDBusConnection | connection () const
bool | isDelayedReply () const
const QDBusMessage & | message () const
void | sendErrorReply ( const QString & name, const QString & msg = QString() ) const
void | sendErrorReply ( QDBusError::ErrorType type, const QString & msg = QString() ) const
void | setDelayedReply ( bool enable ) const

## Detailed Description

The QDBusContext class allows slots to determine the D-Bus context of the calls.

When a slot is called in an object due to a signal delivery or due to a remote method call, it is sometimes necessary to know the context in which that happened. In particular, if the slot determines that it wants to send the reply at a later opportunity or if it wants to reply with an error, the context is needed.

The QDBusContext class is an alternative to accessing the context that doesn't involve modifying the code generated by the QtDBus XML Compiler (qdbusxml2cpp).

QDBusContext is used by subclassing it from the objects being exported using QDBusConnection::registerObject(). The following example illustrates the usage:

     class MyObject: public QObject,
                     protected QDBusContext
     {
         Q_OBJECT
         QDBusConnection conn;
         QDBusMessage msg;

     ...

     protected slots:
         void process();
     public slots:
         void methodWithError();
         QString methodWithDelayedReply();
     };

     void MyObject::methodWithError()
     {
         sendErrorReply(QDBusError::NotSupported,
                        "The method call 'methodWithError()' is not supported");
     }

     QString MyObject::methodWithDelayedReply()
     {
         conn = connection();
         msg = message();
         setDelayedReply(true);
         QMetaObject::invokeMethod(this, "process", Qt::QueuedConnection);
         return QString();
     }

The example illustrates the two typical uses, that of sending error replies and that of delayed replies.

Note: do not subclass QDBusContext and QDBusAbstractAdaptor at the same time. QDBusContext should appear in the real object, not the adaptor. If it's necessary from the adaptor code to determine the context, use a public inheritance and access the functions via QObject::parent().

## Member Function Documentation

### QDBusContext::QDBusContext ()

Constructs an empty QDBusContext.

### QDBusContext::~QDBusContext ()

An empty destructor.

### bool QDBusContext::calledFromDBus () const

Returns true if we are processing a D-Bus call. If this function returns true, the rest of the functions in this class are available.

Accessing those functions when this function returns false is undefined and may lead to crashes.

### QDBusConnection QDBusContext::connection () const

Returns the connection from which this call was received.

### bool QDBusContext::isDelayedReply () const

Returns true if this call will have a delayed reply.

See also setDelayedReply().

### const QDBusMessage & QDBusContext::message () const

Returns the message that generated this call.

### void QDBusContext::sendErrorReply ( const QString & name, const QString & msg = QString() ) const

Sends an error name as a reply to the caller. The optional msg parameter is a human-readable text explaining the failure.

If an error is sent, the return value and any output parameters from the called slot will be ignored by QtDBus.

### void QDBusContext::sendErrorReply ( QDBusError::ErrorType type, const QString & msg = QString() ) const

This is an overloaded function.

Sends an error type as a reply to the caller. The optional msg parameter is a human-readable text explaining the failure.

If an error is sent, the return value and any output parameters from the called slot will be ignored by QtDBus.

### void QDBusContext::setDelayedReply ( bool enable ) const

Sets whether this call will have a delayed reply or not.

If enable is false, QtDBus will automatically generate a reply back to the caller, if needed, as soon as the called slot returns.

If enable is true, QtDBus will not generate automatic replies. It will also ignore the return value from the slot and any output parameters. Instead, the called object is responsible for storing the incoming message and send a reply or error at a later time.

Failing to send a reply will result in an automatic timeout error being generated by D-Bus.

See also isDelayedReply().